function[] = attach_struct(s,prefix)
% ATTACH_STRUCT attaches fields in structure to current workspace
% based on the implementation by JEREMY R. MANNING
% https://de.mathworks.com/matlabcentral/fileexchange/35436-attach

if (nargin == 1); prefix = ''; end

assert(length(s) <= 1,'struct arrays are not supported.  ensure length(s) <= 1.');
if isempty(s), return; end
assert(isstruct(s),'must pass in a structure');
names = fieldnames(s);
vals = cellfun(@getfield,repmat({s},size(names,1),size(names,2)),fieldnames(s),'UniformOutput',false);
cellfun(@assignin,repmat({'caller'},size(names,1),size(names,2)),strcat(prefix,names),vals);
